#ifndef ANIMAL_H
#define ANIMAL_H

#include "Bool.h"

class Animal
{
public:
    Animal(const char *symbol, int initX, int initY, 
           int maxTimeToSleep, int stepSize,
           int maxNumberOfWatchedRacer, int aheadSteps);
    ~Animal();
    BOOL addToWatchList(const Animal &);
    int numberOfWatchedRacers() const;
    BOOL getTo(int position) const;
    void runOneStep();
    void moveTo(int x, int y);
    
private:
    void erase() const;
    void draw() const;
    BOOL isTimeToTakeARest() const;

    const int m_maxNumberOfWatchedRacers;
    int m_numberOfWatchedRacers;
    const Animal ** m_watchedRacers;
    
    int m_xPos; // absolute position on the screen
    int m_yPos;
    
    char m_symbol[3]; // Note: you need some extra effort to make it const
    
    const int m_maxTimeToSleep;
    int m_timeToSleep;
    const int m_stepSize;
    const int m_aheadSteps;
};

#endif