#ifndef RACE_H
#define RACE_H

#include "Bool.h"
class Animal;

class Race
{
public:
    Race(int xOrg, int yOrg, int maxTracks, int fieldLength);
    ~Race();
    BOOL addRacer(Animal &);
    int  numberOfRacers() const;
    void go() const;
    void reportResult() const;

private:
    const int m_maxTracks;
    const int m_fieldLength;
    const int m_fieldXOrg;
    const int m_fieldYOrg;
    
    void drawTracks() const;
    void randomizeSequence(int runningSequence[]) const;
    BOOL endOfRace() const;
    void moveEachRacerToTheirStartPositions() const;
    
    Animal **m_racers;
    int m_numberOfRacers;
};

#endif